#
# Cookbook Name:: deploy_runner
# Recipe:: default
#
# Copyright 2013, Rackspace
#
# All rights reserved - Do Not Redistribute
#

# Install deploy scripts on nodes
%w[
  restricted_ssh.sh
  run_chef.sh
].each do |script|
  cookbook_file "/usr/local/bin/#{script}" do
    mode 555
  end
end

template '/usr/local/bin/deploy.sh' do
  mode 555
  variables ssh_keys: node['deploy_runner']['bundle_url_prefix']
end

home_dir = '/home/deploy'

user 'deploy' do
  home home_dir
  shell '/bin/bash'
  comment 'Deployment user'
  supports manage_home: true
end

directory "#{home_dir}/.ssh" do
  owner 'deploy'
  group 'deploy'
  mode 700
end

file '/etc/sudoers.d/deploy' do
  content "deploy ALL = (root) NOPASSWD: /usr/local/bin/run_chef.sh\n"
  mode 440
end

file "#{home_dir}/.ssh/authorized_keys" do
  not_if { node['deploy_runner']['ssh_key'].nil? }
  content "command=\"/usr/local/bin/restricted_ssh.sh\",no-port-forwarding,no-X11-forwarding,no-agent-forwarding #{node['deploy_runner']['ssh_key']}"
  owner 'deploy'
  group 'deploy'
  mode 400
end
